/*
 * DE0 USB Host demo.
 * (HUB, mouse)
 */

#include <stdio.h>
#include <system.h>
#include <unistd.h>
#include "io.h"
#include "altera_avalon_pio_regs.h"
#include "alt_types.h"
#include "usbh_hw_reg.h"
#include "usbh_env.h"
#include "video.h"

un_hid_mouse mouse_data;
volatile int fit_status;
volatile int video_status;
volatile int fb_front;


// mouse callback
void on_mouse(int buttons, int x, int y, int z) {
	  mouse_data.BYTE.x = x;
	  mouse_data.BYTE.y = y;
	  mouse_data.BYTE.b = buttons;
  printf("mouse changed %x %x %x %x\r\n",buttons,x,y,z);
}


int main()
{
  int i,r;
  printf("DE0 USB Host demo\n");
  // LED test
  // USB reg access test
  //r = IORD_32DIRECT(FM_TOP_0_BASE,0);
  //r = IORD_32DIRECT(0x1000,0xe1*4);
  //printf("usb vreg %x\n",r);
  //r = IORD_32DIRECT(0x1000,0x1*4);
  //printf("usb treg %x\n",r);
  //IOWR_32DIRECT(0x1000,0x1*4,2);
  //r = IORD_32DIRECT(0x1000,0x1*4);
  //printf("usb treg %x\n",r);
  i = 0;
  uh_init();
  
  
  uh_mouse_attach_func(on_mouse);
  video_init();

  while(1) {
   	  uh_update();
   	  video_update();
  }
  return 0;
}
